#include "stdafx.h"
#include "settings.h"
#include "Crypto.h"

using namespace MFC;

AccountSettings accountSettings;
BOOL firstRun;

AccountSettings::AccountSettings()
{
	CString str;
	LPTSTR ptr;
	//--
	logFile.Format("%s.log", _GLOBAL_NAME);
	iniFile.Format("%s.ini", _GLOBAL_NAME);

	CFileStatus rStatus;
	CString appData;
	ptr = appData.GetBuffer(MAX_PATH);
	::GetCurrentDirectory(MAX_PATH, ptr);
	appData.ReleaseBuffer();
	appData += "\\";

	CString appDataLocal;
	ptr = appDataLocal.GetBuffer(MAX_PATH);
	SHGetSpecialFolderPath(
		0,
		ptr, 
		CSIDL_LOCAL_APPDATA, 
		FALSE ); 
	appDataLocal.ReleaseBuffer();
	appDataLocal.AppendFormat("\\%s\\",_GLOBAL_NAME);

	CString appDataRoaming;
	ptr = appDataRoaming.GetBuffer(MAX_PATH);
	SHGetSpecialFolderPath(
		0,
		ptr, 
		CSIDL_APPDATA,
		FALSE ); 
	appDataRoaming.ReleaseBuffer();
	appDataRoaming.AppendFormat("\\%s\\",_GLOBAL_NAME);

	firstRun = TRUE;
	if (CFile::GetStatus(appData + iniFile, rStatus)) {
		firstRun = FALSE;
	}

	HANDLE h = CreateFile( appData + iniFile, GENERIC_WRITE, FILE_SHARE_DELETE | FILE_SHARE_READ |
		FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
	if (h != INVALID_HANDLE_VALUE )
	{
		LARGE_INTEGER filesize;
		// copy ini from appdata to workdir
		if (::GetFileSizeEx(h, &filesize) && filesize.LowPart==0 ) {
			CloseHandle(h);
			CopyFile(appDataRoaming + iniFile, appData + iniFile,  FALSE);
		} else {
			CloseHandle(h);
		}
		iniFile = appData + iniFile;
		logFile = appData + logFile;
	} else {
		CreateDirectory(appDataRoaming, NULL);
		CreateDirectory(appDataLocal, NULL);
		if (CFile::GetStatus(appDataRoaming + iniFile, rStatus)) {
			firstRun = FALSE;
		} else {
			// move ini file from old location
			MoveFile(appDataLocal + iniFile, appDataRoaming + iniFile);
			// copy ini from workdir to appdata
			CopyFile(appData + iniFile, appDataRoaming + iniFile,  TRUE);
		}
		iniFile = appDataRoaming + iniFile;
		logFile = appDataLocal + logFile;
	}
	//--

	ptr = publicAddr.GetBuffer(255);
	GetPrivateProfileString("Settings","PublicAddr", NULL, ptr, 256, iniFile);
	publicAddr.ReleaseBuffer();
	ptr = listenPort.GetBuffer(255);
	GetPrivateProfileString("Settings","ListenPort", NULL, ptr, 256, iniFile);
	listenPort.ReleaseBuffer();


	ptr = server.GetBuffer(255);
	GetPrivateProfileString("Settings","Server", NULL, ptr, 256, iniFile);
	server.ReleaseBuffer();

	ptr = proxy.GetBuffer(255);
	GetPrivateProfileString("Settings","Proxy", NULL, ptr, 256, iniFile);
	proxy.ReleaseBuffer();

	ptr = srtp.GetBuffer(255);
	GetPrivateProfileString("Settings","SRTP", NULL, ptr, 256, iniFile);
	srtp.ReleaseBuffer();

	ptr = transport.GetBuffer(255);
	GetPrivateProfileString("Settings","Transport", NULL, ptr, 256, iniFile);
	transport.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","Publish", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	publish=str=="1"?1:0;

	ptr = stun.GetBuffer(255);
	GetPrivateProfileString("Settings","STUN", NULL, ptr, 256, iniFile);
	stun.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","ICE", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	ice=str=="1"?1:0;

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","allowRewrite", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	allowRewrite=str=="1"?1:0;


	ptr = domain.GetBuffer(255);
	GetPrivateProfileString("Settings","Domain", NULL, ptr, 256, iniFile);
	domain.ReleaseBuffer();

	ptr = authID.GetBuffer(255);
	GetPrivateProfileString("Settings","AuthID", NULL, ptr, 256, iniFile);
	authID.ReleaseBuffer();

	CString usernameLocal;
	CString passwordLocal;
	ptr = usernameLocal.GetBuffer(255);
	GetPrivateProfileString("Settings","Username", NULL, ptr, 256, iniFile);
	usernameLocal.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","PasswordSize", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	if (str!="") {
		CByteArray arPassword;
		int size = atoi(str);
		arPassword.SetSize(size>0?size:16);
		GetPrivateProfileStruct("Settings", "Password", arPassword.GetData(),arPassword.GetSize(), iniFile);
		CCrypto crypto;
		if (crypto.DeriveKey(_GLOBAL_KEY)) {
			crypto.Decrypt(arPassword,passwordLocal);
		}
	} else {
		ptr = passwordLocal.GetBuffer(255);
		GetPrivateProfileString("Settings","Password", NULL, ptr, 256, iniFile);
		passwordLocal.ReleaseBuffer();
	}

	rememberPassword = passwordLocal.GetLength()?1:0;


	username = usernameLocal;
	password = passwordLocal;


	ptr = displayName.GetBuffer(255);
	GetPrivateProfileString("Settings","DisplayName", NULL, ptr, 256, iniFile);
	displayName.ReleaseBuffer();

	ptr = updatesInterval.GetBuffer(255);
	GetPrivateProfileString("Settings","UpdatesInterval", NULL, ptr, 256, iniFile);
	updatesInterval.ReleaseBuffer();
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","CheckUpdatesTime", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	checkUpdatesTime = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","disableLocalAccount", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	disableLocalAccount=str=="1"?1:0;

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","AutoAnswer", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	autoAnswer=str=="1"?1:(str=="2"?2:0);

	ptr = userAgent.GetBuffer(255);
	GetPrivateProfileString("Settings","userAgent", NULL, ptr, 256, iniFile);
	userAgent.ReleaseBuffer();

	ptr = denyIncoming.GetBuffer(255);
	GetPrivateProfileString("Settings","denyIncoming", NULL, ptr, 256, iniFile);
	denyIncoming.ReleaseBuffer();

	ptr = usersDirectory.GetBuffer(255);
	GetPrivateProfileString("Settings","usersDirectory", NULL, ptr, 256, iniFile);
	usersDirectory.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","LocalDTMF", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	localDTMF=str=="0"?0:1;

	ptr = ringingSound.GetBuffer(255);
	GetPrivateProfileString("Settings","RingingSound", NULL, ptr, 256, iniFile);
	ringingSound.ReleaseBuffer();
	ptr = audioInputDevice.GetBuffer(255);
	GetPrivateProfileString("Settings","AudioInputDevice", NULL, ptr, 256, iniFile);
	audioInputDevice.ReleaseBuffer();
	ptr = audioOutputDevice.GetBuffer(255);
	GetPrivateProfileString("Settings","AudioOutputDevice", NULL, ptr, 256, iniFile);
	audioOutputDevice.ReleaseBuffer();
	ptr = audioRingDevice.GetBuffer(255);
	GetPrivateProfileString("Settings","AudioRingDevice", NULL, ptr, 256, iniFile);
	audioRingDevice.ReleaseBuffer();
	
	ptr = audioCodecs.GetBuffer(255);
	GetPrivateProfileString("Settings","AudioCodecs", NULL, ptr, 256, iniFile);
	audioCodecs.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","vad", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	vad = str == "1" ? 1 : 0;

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","ec", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	ec = str == "1" ? 1 : 0;

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","forceCodec", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();

	forceCodec = str == "1" ? 1 : 0;

#ifdef _GLOBAL_VIDEO
	ptr = videoCaptureDevice.GetBuffer(255);
	GetPrivateProfileString("Settings","VideoCaptureDevice", NULL, ptr, 256, iniFile);
	videoCaptureDevice.ReleaseBuffer();
	ptr = videoCodec.GetBuffer(255);
	GetPrivateProfileString("Settings","VideoCodec", NULL, ptr, 256, iniFile);
	videoCodec.ReleaseBuffer();
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","DisableH264", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	disableH264 = str == "1" ? 1 : 0;
	ptr = bitrateH264.GetBuffer(255);
	GetPrivateProfileString("Settings","BitrateH264", NULL, ptr, 256, iniFile);
	bitrateH264.ReleaseBuffer();
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","DisableH263", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	disableH263 = str == "1" ? 1 : 0;
	ptr = bitrateH263.GetBuffer(255);
	GetPrivateProfileString("Settings","BitrateH263", NULL, ptr, 256, iniFile);
	bitrateH263.ReleaseBuffer();
#endif

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","mainX", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	mainX = atoi(str);
	
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","mainY", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	mainY = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","mainW", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	mainW = atoi(str);
	
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","mainH", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	mainH = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","messagesX", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	messagesX = atoi(str);
	
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","messagesY", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	messagesY = atoi(str);
	
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","messagesW", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	messagesW = atoi(str);
	
	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","messagesH", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	messagesH = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","callsWidth0", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	callsWidth0 = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","callsWidth1", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	callsWidth1 = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","callsWidth2", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	callsWidth2 = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","callsWidth3", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	callsWidth3 = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","callsWidth4", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	callsWidth4 = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","volumeOutput", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	volumeOutput = str==""?100:atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","volumeInput", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	volumeInput = str==""?100:atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","ActiveTab", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	activeTab = atoi(str);

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","AlwaysOnTop", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	alwaysOnTop = atoi(str);

	ptr = cmdIncomingCall.GetBuffer(255);
	GetPrivateProfileString("Settings","cmdIncomingCall", NULL, ptr, 256, iniFile);
	cmdIncomingCall.ReleaseBuffer();

	ptr = cmdCallAnswer.GetBuffer(255);
	GetPrivateProfileString("Settings","cmdCallAnswer", NULL, ptr, 256, iniFile);
	cmdCallAnswer.ReleaseBuffer();

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","EnableLog", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	enableLog=str=="1"?1:0;

	ptr = str.GetBuffer(255);
	GetPrivateProfileString("Settings","SingleMode", NULL, ptr, 256, iniFile);
	str.ReleaseBuffer();
	singleMode=str=="1"?1:0;

	hidden = 0;
}

void AccountSettings::Save()
{
	CString str;

		WritePrivateProfileString("Settings","Server",server,iniFile);

	WritePrivateProfileString("Settings","Proxy",proxy,iniFile);

	WritePrivateProfileString("Settings","Domain",domain,iniFile);

	WritePrivateProfileString("Settings","AuthID",authID,iniFile);

	CString usernameLocal;
	CString passwordLocal;

	usernameLocal = username;
	passwordLocal = password;

	CCrypto crypto;
	CByteArray arPassword;
	if (crypto.DeriveKey(_GLOBAL_KEY)) {
		crypto.Encrypt(passwordLocal,arPassword);
	}

	if (!rememberPassword) {
		WritePrivateProfileString("Settings","Username","",iniFile);
		WritePrivateProfileString("Settings","Password","",iniFile);
		WritePrivateProfileString("Settings","PasswordSize",NULL,iniFile);
	}

	if (rememberPassword) {
		WritePrivateProfileString("Settings","Username",usernameLocal,iniFile);
		if (arPassword.GetSize()) {
			WritePrivateProfileStruct("Settings","Password",arPassword.GetData(),arPassword.GetSize(),iniFile);
			CString str;
			str.Format("%d",arPassword.GetSize());
			WritePrivateProfileString("Settings","PasswordSize",str,iniFile);
		} else {
			WritePrivateProfileString("Settings","Password",passwordLocal,iniFile);
			WritePrivateProfileString("Settings","PasswordSize",NULL,iniFile);
		}
	}

	WritePrivateProfileString("Settings","DisplayName",displayName,iniFile);

	WritePrivateProfileString("Settings","PublicAddr",publicAddr,iniFile);
	WritePrivateProfileString("Settings","ListenPort",listenPort,iniFile);
	WritePrivateProfileString("Settings","SRTP",srtp,iniFile);
	WritePrivateProfileString("Settings","Transport",transport,iniFile);
	WritePrivateProfileString("Settings","Publish",publish?"1":"0",iniFile);
	WritePrivateProfileString("Settings","STUN",stun,iniFile);
	WritePrivateProfileString("Settings","ICE",ice?"1":"0",iniFile);
	WritePrivateProfileString("Settings","allowRewrite",allowRewrite?"1":"0",iniFile);
	WritePrivateProfileString("Settings","disableLocalAccount",disableLocalAccount?"1":"0",iniFile);

	WritePrivateProfileString("Settings","EnableLog",enableLog?"1":"0",iniFile);

	WritePrivateProfileString("Settings","UpdatesInterval",updatesInterval,iniFile);
	str.Format("%d",checkUpdatesTime);
	WritePrivateProfileString("Settings","CheckUpdatesTime",str,iniFile);

	WritePrivateProfileString("Settings","AutoAnswer",autoAnswer==1?"1":(autoAnswer==2?"2":"0"),iniFile);
	WritePrivateProfileString("Settings","denyIncoming",denyIncoming,iniFile);
	WritePrivateProfileString("Settings","usersDirectory",usersDirectory,iniFile);
	WritePrivateProfileString("Settings","SingleMode",singleMode?"1":"0",iniFile);
	WritePrivateProfileString("Settings","LocalDTMF",localDTMF?"1":"0",iniFile);
	WritePrivateProfileString("Settings","RingingSound",ringingSound,iniFile);
	WritePrivateProfileString("Settings","AudioInputDevice","\""+audioInputDevice+"\"",iniFile);
	WritePrivateProfileString("Settings","AudioOutputDevice","\""+audioOutputDevice+"\"",iniFile);
	WritePrivateProfileString("Settings","AudioRingDevice","\""+audioRingDevice+"\"",iniFile);
	WritePrivateProfileString("Settings","AudioCodecs",audioCodecs,iniFile);
	WritePrivateProfileString("Settings","vad",vad?"1":"0",iniFile);
	WritePrivateProfileString("Settings","ec",ec?"1":"0",iniFile);
	WritePrivateProfileString("Settings","forceCodec",forceCodec?"1":"0",iniFile);
#ifdef _GLOBAL_VIDEO
	WritePrivateProfileString("Settings","VideoCaptureDevice","\""+videoCaptureDevice+"\"",iniFile);
	WritePrivateProfileString("Settings","VideoCodec",videoCodec,iniFile);
	WritePrivateProfileString("Settings","DisableH264",disableH264?"1":"0",iniFile);
	WritePrivateProfileString("Settings","BitrateH264",bitrateH264,iniFile);
	WritePrivateProfileString("Settings","DisableH263",disableH263?"1":"0",iniFile);
	WritePrivateProfileString("Settings","BitrateH263",bitrateH263,iniFile);
#endif

	str.Format("%d",mainX);
	WritePrivateProfileString("Settings","mainX",str,iniFile);

	str.Format("%d",mainY);
	WritePrivateProfileString("Settings","mainY",str,iniFile);

	str.Format("%d",mainW);
	WritePrivateProfileString("Settings","mainW",str,iniFile);

	str.Format("%d",mainH);
	WritePrivateProfileString("Settings","mainH",str,iniFile);

	str.Format("%d",messagesX);
	WritePrivateProfileString("Settings","messagesX",str,iniFile);

	str.Format("%d",messagesY);
	WritePrivateProfileString("Settings","messagesY",str,iniFile);

	str.Format("%d",messagesW);
	WritePrivateProfileString("Settings","messagesW",str,iniFile);

	str.Format("%d",messagesH);
	WritePrivateProfileString("Settings","messagesH",str,iniFile);

	str.Format("%d",callsWidth0);
	WritePrivateProfileString("Settings","callsWidth0",str,iniFile);
		
	str.Format("%d",callsWidth1);
	WritePrivateProfileString("Settings","callsWidth1",str,iniFile);

	str.Format("%d",callsWidth2);
	WritePrivateProfileString("Settings","callsWidth2",str,iniFile);

	str.Format("%d",callsWidth3);
	WritePrivateProfileString("Settings","callsWidth3",str,iniFile);

	str.Format("%d",callsWidth4);
	WritePrivateProfileString("Settings","callsWidth4",str,iniFile);

	str.Format("%d",volumeOutput);
	WritePrivateProfileString("Settings","volumeOutput",str,iniFile);

	str.Format("%d",volumeInput);
	WritePrivateProfileString("Settings","volumeInput",str,iniFile);

	str.Format("%d",activeTab);
	WritePrivateProfileString("Settings","ActiveTab",str,iniFile);

	str.Format("%d",alwaysOnTop);
	WritePrivateProfileString("Settings","AlwaysOnTop",str,iniFile);
	
	WritePrivateProfileString("Settings","cmdIncomingCall",cmdIncomingCall,iniFile);
	WritePrivateProfileString("Settings","cmdCallAnswer",cmdCallAnswer,iniFile);
	
}
